/* Copyright (C) 2011-2012 Red Hat, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#ifndef _USER_H
#define _USER_H

#include <stdbool.h>

#define USERNAME_MAX 64
#define USERPASS_MAX 64
struct user {
	char name[USERNAME_MAX+1];
	char pass[USERPASS_MAX+1];
};

extern struct user *user_lookup (const char *userid) _GL_ATTRIBUTE_PURE;
extern void user_add (const char *usercred);
extern bool parse_users (const char *);

#endif /* _USER_H */
